---
- find:
    paths: /etc/firewalld/zones
  register: result

- name: Remove User Zone files
  file:
    path: "{{ item.path }}"
    state: absent
  loop: "{{ result.files }}"
  when: "item.path != '/etc/firewalld/zones/docker.xml'"

- name: Remove Unneeded Zones
  file:
    path: "/usr/lib/firewalld/zones/{{ item }}.xml"
    state: absent
  loop:
    - dmz
    - home
    - nm-shared
    - work
    - external

- name: reload service firewalld
  systemd:
    name: firewalld
    state: reloaded

- name: Configure Zones
  ansible.posix.firewalld:
    zone: "{{ item.zone }}"
    state: enabled
    permanent: yes
  loop: "{{ default_rules }}"

- name: Configure interfaces if any
  ansible.posix.firewalld:
    zone: "{{ item.0.zone }}"
    interface: "{{ item.1 }}"
    state: enabled
    permanent: yes
  with_subelements:
    - "{{ default_rules }}"
    - interfaces

- name: Configure source addresses if any
  ansible.posix.firewalld:
    zone: "{{ item.0.zone }}"
    source: "{{ item.1 }}"
    state: enabled
    permanent: yes
  with_subelements:
    - "{{ default_rules }}"
    - sources

- name: Configure services
  ansible.posix.firewalld:
    zone: "{{ item.0.zone }}"
    service: "{{ item.1 }}"
    state: enabled
    permanent: yes
  with_subelements:
    - "{{ default_rules }}"
    - rules.services

- name: Configure Ports
  ansible.posix.firewalld:
    zone: "{{ item.0.zone }}"
    port: "{{ item.1 }}"
    state: enabled
    permanent: yes
  with_subelements:
    - "{{ default_rules }}"
    - rules.ports

- name: Configure rich rules
  ansible.posix.firewalld:
    zone: "{{ item.0.zone }}"
    rich_rule: "{{ item.1 }}"
    state: enabled
    permanent: yes
  with_subelements:
    - "{{ default_rules }}"
    - rules.rich_rules

- name: Remove Unneeded Service Rules
  block:
    - ansible.posix.firewalld:
        zone: public
        service: "{{ item }}"
        state: disabled
        permanent: yes
      loop:
        - cockpit
        - dhcpv6-client
        - ssh
        - mdns
        - samba-client

    - ansible.posix.firewalld:
        zone: internal
        service: "{{ item }}"
        state: disabled
        permanent: yes
      loop:
        - cockpit
        - dhcpv6-client
        - mdns
        - samba-client

- name: reload service firewalld
  systemd:
    name: firewalld
    state: reloaded
